/*
 * Copyright (c) 2001-2006, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: AbstractParticipant.java 2717 2006-06-01 15:26:06Z jmettraux $
 */

//
// AbstractParticipant.java
//
// jmettraux@openwfe.org
//
// generated with 
// jtmpl 1.0.04 20.11.2001 John Mettraux (jmettraux@openwfe.org)
//

package openwfe.org.engine.participants;


/**
 * A participant to a workflow.
 * Its name, its dispatcher class and a few parameters
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Date: 2006-06-01 17:26:06 +0200 (Thu, 01 Jun 2006) $
 * <br>$Id: AbstractParticipant.java 2717 2006-06-01 15:26:06Z jmettraux $ </font>
 *
 * @author john.mettraux@openwfe.org
 */
public abstract class AbstractParticipant

    implements Participant

{

    /*
    private final static org.apache.log4j.Logger log = org.apache.log4j.Logger
        .getLogger(AbstractParticipant.class.getName());
    */

    //
    // CONSTANTS & co

    /**
     * The parameter 'dispatcherClass' tells the participant which 
     * implementation of openwfe.org.engine.dispatch.WorkItemDispatcher it
     * should use.
     * A participant doesn't necessarily need a dispatcher though.
     */
    public final static String P_DISPATCHER_CLASS
        = "dispatcherClass";

    //
    // FIELDS

    //private ParticipantMap participantMap = null;
    private String regex = null;
    private java.util.Map params = null;

    //
    // CONSTRUCTORS

    public void init
        (//final ParticipantMap pMap,
         final String regex,
         final java.util.Map params)
    {
        //this.participantMap = pMap;
        this.regex = regex;
        this.params = params;

        //pMap.add(this);
    }

    //
    // GETTERS and SETTERS

    //public ParticipantMap getParticipantMap () { return this.participantMap; }
    public String getRegex () { return this.regex; }
    public void setRegex (final String s) { this.regex = s; }
    public java.util.Map getParams () { return this.params; }

    //
    // METHODS

}
